"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.nftPaymentGuardManifest = void 0;
const mpl_essentials_1 = require("@metaplex-foundation/mpl-essentials");
const mpl_token_metadata_1 = require("@metaplex-foundation/mpl-token-metadata");
const generated_1 = require("../generated");
const guards_1 = require("../guards");
exports.nftPaymentGuardManifest = {
    name: 'nftPayment',
    serializer: generated_1.getNftPaymentSerializer,
    mintParser: (context, mintContext, args) => {
        const nftTokenAccount = args.tokenAccount ??
            (0, mpl_essentials_1.findAssociatedTokenPda)(context, {
                mint: args.mint,
                owner: mintContext.minter.publicKey,
            });
        const nftMetadata = (0, mpl_token_metadata_1.findMetadataPda)(context, { mint: args.mint });
        const destinationAta = (0, mpl_essentials_1.findAssociatedTokenPda)(context, {
            mint: args.mint,
            owner: args.destination,
        });
        return {
            data: new Uint8Array(),
            remainingAccounts: [
                { publicKey: nftTokenAccount, isWritable: true },
                { publicKey: nftMetadata, isWritable: true },
                { publicKey: args.mint, isWritable: false },
                { publicKey: args.destination, isWritable: false },
                { publicKey: destinationAta, isWritable: true },
                {
                    publicKey: (0, mpl_essentials_1.getSplAssociatedTokenProgramId)(context),
                    isWritable: false,
                },
            ],
        };
    },
    routeParser: guards_1.noopParser,
};
//# sourceMappingURL=nftPayment.js.map